/********************************************************************
*  AndroidɂIVXR[v
*  PIC24FJ64GB002gpAUSBėpX[uœ
********************************************************************/
#include <p24fj64gb002.h>
#include "USB/USB.h"
#include "USB/usb_function_generic.h"
#include "HardwareProfile.h"
#include "GenericTypeDefs.h"
#include "usb_config.h"
/******* RtBM[Vݒ *****/
_CONFIG1(WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & GCP_OFF & JTAGEN_OFF & GWRP_OFF) 
_CONFIG2(POSCMOD_NONE & I2C1SEL_PRI & OSCIOFNC_OFF & FCKSM_CSDCMD 
			& FNOSC_FRCPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
_CONFIG3(SOSCSEL_IO)
/******** USB֘Aobt@Aϐ` ****/
#pragma udata
int Buffer[2048];						// vpobt@
BYTE INPacket[64];					// USBMobt@
BYTE OUTPacket[64];					// USBMobt@
USB_HANDLE USBGenericOutHandle;
USB_HANDLE USBGenericInHandle;
/**** ϐ`@***/
BYTE  counter, BlockCounter,BusyFlag;
int DataCounter;
int i, j;
/*** R}h萔` ***/
typedef enum
{
    TRIG	= 0x31,
	NEXT	= 0x32,
	FREQ	= 0x33
}TYPE_CMD;
/** ֐vg^CsO ****************************/
void USBDeviceTasks(void);
void USBCBSendResume(void);
void BlinkUSBStatus(void);
void ProcessIO(void);
void Hsync(BYTE num);

#pragma code
/************ C֐ ********************/
int main(void)
{   
	CLKDIV = 0x0020;						// 96MHz PLL On, CPU:32MHz
	OSCTUN = 0x0000;						// NbNg
	/* o̓|[gݒ  */
	TRISA = 0x000F;							// OSC SÎݓ 
	TRISB = 0x1C03;							// o̓[hZbg 
	// Setup ADC
	AD1CON1 = 0x8044;						// ADI,,^C}RŃgK
	AD1CON2 = 0x001E;						// AVdd, AVss, 8񂲂ƂɊ荞,obt@2
	AD1CON3 = 0x0101;						// 31 Tad auto-sample, Tad = 5*Tcy
 	AD1CHS  = 0x0001;						// 4rbgŃ`lw
	AD1PCFG = 0xFFFC;						// RA0,1 ̂݃AiO 
	AD1CSSL = 0;							// XLȂ
	IPC3bits.AD1IP = 7;						// 荞݃xō
	IFS0bits.AD1IF = 0;						// 荞݃tONA
	IEC0bits.AD1IE = 1;						// 荞݋
	/* ^C}RݒiA/DϊgKpj */
	PR3 = 31;								// ő62.5nse~32=2usec
	T3CON = 0x0000;							// Off 1:1 Fosc/2
	DataCounter = 0;
	/* USBAPX^[g */
	USBDeviceInit();						// USB	
	USBGenericInHandle = 0;	
	USBGenericOutHandle = 0;
	/** USBA^b`Ɗ荞݋ */
	USBDeviceAttach();

	/*********** C[v ***************/
    while(1)
    {
		/*** USBڑȂ瑗Ms ***/
		if((USBDeviceState >= CONFIGURED_STATE)&&(USBSuspendControl!=1))
			ProcessIO();					// [U[Avs
	}
}

/***************************************************
 * [U[AvAo͏֐
 * USB̃R}hɂ@\s
 ***************************************************/
void ProcessIO(void)
{
	/***** f[^M ******/
	if(!USBHandleBusy(USBGenericOutHandle))				// MH
	{        
		counter = 0;									// MoCgZbg
		/******** MR}hƂ̏ ********/
		switch(OUTPacket[0])							// R}hR[h`FbN
		{
			case TRIG:		/** f[^vJngK ***/		
				INPacket[0] = 'O';						// OKZbg
				INPacket[1] = 'K';
				// TvOݒƃobt@
				T3CONbits.TON = 0;						// ^C}R~
				TMR3 = 0;
				AD1CON1 = 0;							// ADIt
				Hsync(OUTPacket[1]);					// Tvݒ
				DataCounter = 0;						// obt@CfbNX
				BlockCounter = 0;
				AD1CON1 = 0x8044;						// ADI,,^C}RŃgK	
				BusyFlag = 1;							// f[^WtOI	
				T3CONbits.TON = 1;						// ^C}RJn
				counter = 2;							// MoCgZbg
				break;						
			case NEXT:		/** ̃f[^]v ***/
				mLED_2_Toggle();						// ڈLED_
				while(BusyFlag == 1);					// f[^W҂
				/* vf[^Mobt@ɃZbg 64oCg */
				for(i=0; i<64; i+=2){
					INPacket[i]   = (BYTE)(Buffer[BlockCounter*32+i/2]%256);
					INPacket[i+1] = (BYTE)(Buffer[BlockCounter*32+i/2]/256);
				}
				BlockCounter++;							// 64oCgPʃJE^
				counter = 64;							// MoCgZbg
				break;
			default:
				break;
		}
		/* Ms@64oCgP */
		if(counter != 0){								// Mf[^肩H
			while(USBHandleBusy(USBGenericInHandle));	// rW[`FbN
			USBGenericInHandle = USBGenWrite(USBGEN_EP_NUM,(BYTE*)&INPacket,64);
		}
		/* ̎Ms 64oCgP */
		USBGenericOutHandle = USBGenRead(USBGEN_EP_NUM,(BYTE*)&OUTPacket,64);
	}
}
/***************************************************
* ؂ւ@^C}R̎ύX
*  PR3 62.5nsecPʂŐݒ
***************************************************/
void Hsync(BYTE num){
	switch(num){
		case 0:
		case 1:
		case 2:
			PR3 = 31;			//32*62.5=2usec
			break;
		case 3:
			PR3 = 79;			//5usec
			break;
		case 4:
			PR3 = 319;			//20usec
			break;
		case 5:
			PR3 = 799;			//50usec
			break;
		default:
			PR3 = 31;
			break;
	}
}	
			
/***************************************************
*  A/Dϊf[^W荞ݏ֐
*  8ϊƂɊ荞ݐ@_uobt@
***************************************************/
void __attribute__((interrupt, no_auto_psv)) _ADC1Interrupt(void){
	mLED_1_Toggle();						// ԑp
	IFS0bits.AD1IF = 0;	
	/* vf[^obt@֊i[ 2048 */
	if(AD1CON2bits.BUFS == 1){				// gpobt@`FbN
		Buffer[DataCounter++] = ADC1BUF0;
		Buffer[DataCounter++] = ADC1BUF1;
		Buffer[DataCounter++] = ADC1BUF2;
		Buffer[DataCounter++] = ADC1BUF3;
		Buffer[DataCounter++] = ADC1BUF4;
		Buffer[DataCounter++] = ADC1BUF5;
		Buffer[DataCounter++] = ADC1BUF6;
		Buffer[DataCounter++] = ADC1BUF7;
	}
	else{
		Buffer[DataCounter++] = ADC1BUF8;
		Buffer[DataCounter++] = ADC1BUF9;
		Buffer[DataCounter++] = ADC1BUFA;
		Buffer[DataCounter++] = ADC1BUFB;
		Buffer[DataCounter++] = ADC1BUFC;
		Buffer[DataCounter++] = ADC1BUFD;
		Buffer[DataCounter++] = ADC1BUFE;
		Buffer[DataCounter++] = ADC1BUFF;
	}				
	if(DataCounter >= 2047){				// 2048ϊH
		T3CONbits.TON = 0;					// ^C}R~
		DataCounter = 0;
		BusyFlag = 0;						// ϊI҂tO
	}
}			

/******************************************************************
************** USB Callback Functions *****************************
*******************************************************************/
/******************************************************************
 * Function:        void USBCBSuspend(void)
 ******************************************************************/
void USBCBSuspend(void)
{
}
/*******************************************************************
 * Function:        void USBCBWakeFromSuspend(void)
 *******************************************************************/
void USBCBWakeFromSuspend(void)
{
}
/********************************************************************
 * Function:        void USBCB_SOF_Handler(void)
 *******************************************************************/
void USBCB_SOF_Handler(void)
{
}
/*******************************************************************
 * Function:        void USBCBErrorHandler(void)
 *******************************************************************/
void USBCBErrorHandler(void)
{
}
/*******************************************************************
 * Function:        void USBCBCheckOtherReq(void)
 *******************************************************************/
void USBCBCheckOtherReq(void)
{
}//end
/*******************************************************************
 * Function:        void USBCBStdSetDscHandler(void)
 *******************************************************************/
void USBCBStdSetDscHandler(void)
{
}//end
/*******************************************************************
 * Function:        void USBCBInitEP(void)
 *******************************************************************/
void USBCBInitEP(void)
{
    USBEnableEndpoint(USBGEN_EP_NUM,USB_OUT_ENABLED|USB_IN_ENABLED|USB_HANDSHAKE_ENABLED|USB_DISALLOW_SETUP);
    USBGenericOutHandle = USBGenRead(USBGEN_EP_NUM,(BYTE*)&OUTPacket,USBGEN_EP_SIZE);
}
/*******************************************************************
 * Function:        void USBCBSendResume(void)
 ******************************************************************/
void USBCBSendResume(void)
{
    static WORD delay_count;

    if(USBGetRemoteWakeupStatus() == TRUE) 
    {
        //Verify that the USB bus is in fact suspended, before we send
        //remote wakeup signalling.
        if(USBIsBusSuspended() == TRUE)
        {
            USBMaskInterrupts();
            
            //Clock switch to settings consistent with normal USB operation.
            USBCBWakeFromSuspend();
            USBSuspendControl = 0; 
            USBBusIsSuspended = FALSE;  //So we don't execute this code again, 

            delay_count = 3600U;
            do
            {
                delay_count--;
            }while(delay_count);
            
            //Now drive the resume K-state signalling onto the USB bus.
            USBResumeControl = 1;       // Start RESUME signaling
            delay_count = 1800U;        // Set RESUME line for 1-13 ms
            do
            {
                delay_count--;
            }while(delay_count);
            USBResumeControl = 0;       //Finished driving resume signalling

            USBUnmaskInterrupts();
        }
    }
}
/*******************************************************************
 * Function:        BOOL USER_USB_CALLBACK_EVENT_HANDLER(
 *******************************************************************/
BOOL USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, WORD size)
{
    switch(event)
    {
        case EVENT_TRANSFER:
            break;
        case EVENT_SOF:
            USBCB_SOF_Handler();
            break;
        case EVENT_SUSPEND:
            USBCBSuspend();
            break;
        case EVENT_RESUME:
            USBCBWakeFromSuspend();
            break;
        case EVENT_CONFIGURED: 
            USBCBInitEP();
            break;
        case EVENT_SET_DESCRIPTOR:
            USBCBStdSetDscHandler();
            break;
        case EVENT_EP0_REQUEST:
            USBCBCheckOtherReq();
            break;
        case EVENT_BUS_ERROR:
            USBCBErrorHandler();
            break;
        case EVENT_TRANSFER_TERMINATED:

            break;
        default:
            break;
    }      
    return TRUE; 
}
